<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:dfdl="http://www.ogf.org/dfdl/dfdl-1.0/"
    xmlns:fn="http://www.w3.org/2005/xpath-functions"
    xmlns:math="http://www.w3.org/2005/xpath-functions/math"
    exclude-result-prefixes="xs"
    version="2.0">
    
    <!--
        NOTICE
        
        This software was produced for the U. S. Government under
        Basic Contract No. W15P7T-13-C-A802, and is subject to the
        Rights in Noncommercial Computer Software and Noncommercial
        Computer Software Documentation Clause 252.227-7014 (FEB 2012)
        
        Copyright 2019 The MITRE Corporation.
    -->
    
    <xsl:output method="xml" />
    
    <xsl:template match="names">
        <xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
            xmlns:dfdl="http://www.ogf.org/dfdl/dfdl-1.0/"
            xmlns:fn="http://www.w3.org/2005/xpath-functions"
            elementFormDefault="qualified">
            
            <xs:include schemaLocation="default-dfdl-properties/defaults.dfdl.xsd" />
            
            <xs:annotation>
                <xs:appinfo source="http://www.ogf.org/dfdl/">
                    <dfdl:format ref="default-dfdl-properties" />
                </xs:appinfo>
            </xs:annotation>
            
            <xs:element name="names">
                <xs:complexType>
                    <xs:sequence dfdl:separator="%NL;" dfdl:separatorPosition="infix">
                        <xs:element name="entry" maxOccurs="unbounded" 
                            dfdl:occursCount="{{ {number-of-names} }}" dfdl:occursCountKind="expression">
                            <xs:complexType>
                                <xs:sequence dfdl:separator=":" dfdl:separatorPosition="infix">
                                    <xs:element name="name" type="xs:string" />
                                    <xs:element name="value" type="xs:string" />
                                </xs:sequence>
                            </xs:complexType>
                        </xs:element>
                        <xs:sequence dfdl:hiddenGroupRef="hidden-num-group" />
                    </xs:sequence>
                </xs:complexType>
            </xs:element>
            
            <xs:group name="hidden-num-group">
                <xs:sequence>
                    <xs:element name="number-of-names" type="xs:integer"
                        dfdl:outputValueCalc="{{{number-of-names}}}" />
                </xs:sequence>
            </xs:group>
            
        </xs:schema>
    </xsl:template>
</xsl:stylesheet>